Package org.zkoss.stateless.sul

## Interface ITreerow

- All Superinterfaces:
    `IChildable<ITreerow,​ITreecell<IAnyGroup>>`, `IComponent<ITreerow>`, `IHtmlBasedComponent<ITreerow>`, `ITreeitemComposite<ITreerow>`, `IXulElement<ITreerow>`

      public interface ITreerow
      extends IXulElement<ITreerow>, IChildable<ITreerow,​ITreecell<IAnyGroup>>, ITreeitemComposite<ITreerow>

  Immutable `Treerow` component
  Author:
    jumperchen
  See Also:
    `Treerow`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `ITreerow.Builder` | Builds instances of type `ITreerow`.
    `static class` | `ITreerow.Updater` | Builds an updater of type `ITreerow` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ITreerow` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getImage()` | Returns the image of the first `ITreecell` it contains, or null if no such treecell.
    `default java.lang.String` | `getLabel()` | Returns the label of the first `ITreecell` it contains, or null if no such treecell.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static ITreerow` | `of​(java.lang.Iterable<? extends ITreecell<IAnyGroup>> children)` | Returns the instance with the given `treecells`.
    `static ITreerow` | `of​(java.lang.String label)` | Returns the instance with a `ITreecell` holding the given label.
    `static ITreerow` | `of​(java.lang.String label, java.lang.String image)` | Returns the instance with a `ITreecell` holding the given label and image.
    `static ITreerow` | `of​(ITreecell<IAnyGroup>... children)` | Returns the instance with the given `treecells`.
    `static ITreerow` | `ofImage​(java.lang.String image)` | Returns the instance with a `ITreecell` holding the given image.
    `ITreerow` | `withImage​(java.lang.String image)` | Returns a copy of `this` immutable component with the specified `image`.
    `ITreerow` | `withLabel​(java.lang.String label)` | Returns a copy of `this` immutable component with the specified `label`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final ITreerow DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.sel.Treerow"`

      Specified by:
        `getWidgetClass` in interface `IComponent<ITreerow>`

    - #### getImage

          @Nullable
          default java.lang.String getImage()

      Returns the image of the first `ITreecell` it contains, or null if no such treecell.

    - #### withImage

          ITreerow withImage​(@Nullable
                             java.lang.String image)

      Returns a copy of `this` immutable component with the specified `image`.

      Sets the image of the first `ITreecell` it contains.

      Note: if no any treecell exists, this method creates one automatically.

      Parameters:
        `image` - The image of the first `ITreecell` it contains.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### getLabel

          @Nullable
          default java.lang.String getLabel()

      Returns the label of the first `ITreecell` it contains, or null if no such treecell.

    - #### withLabel

          ITreerow withLabel​(@Nullable
                             java.lang.String label)

      Returns a copy of `this` immutable component with the specified `label`.

      Sets the label of the first `ITreecell` it contains.

      Note: if no any treecell exists, this method creates one automatically.

      Parameters:
        `label` - The label of the first `ITreecell` it contains.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static ITreerow of​(java.lang.String label)

      Returns the instance with a `ITreecell` holding the given label.
      Parameters:
        `label` - The label of the first `ITreecell`

    - #### of

          static ITreerow of​(java.lang.String label,
                             java.lang.String image)

      Returns the instance with a `ITreecell` holding the given label and image.
      Parameters:
        `label` - The label of the first `ITreecell`
        `image` - The image of the first `ITreecell`

    - #### of

          static ITreerow of​(ITreecell<IAnyGroup>... children)

      Returns the instance with the given `treecells`.
      Parameters:
        `children` - The tree cells of the component

    - #### of

          static ITreerow of​(java.lang.Iterable<? extends ITreecell<IAnyGroup>> children)

      Returns the instance with the given `treecells`.
      Parameters:
        `children` - The tree cells of the component

    - #### ofImage

          static ITreerow ofImage​(java.lang.String image)

      Returns the instance with a `ITreecell` holding the given image.
      Parameters:
        `image` - The image of the first `ITreecell`